SystemOrganization addCategory: #'GT-Debugger'!

GLMBrowserTemplate subclass: #GTDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebugger commentStamp: 'TudorGirba 3/13/2011 23:28' prior: 0!
[ GTDebugger debugProcess: Processor activeProcess.
	Processor activeProcess suspend.
	#(1 2 3 4 5) do: [:each | each asString]
] fork.!

!GTDebugger classSide methodsFor: 'as yet unclassified' stamp: 'AdrianLienhard 2/26/2011 17:19'!
debugIn: anArray

	<primitive: 19> "simulation guard"
	
	
	WorldState addDeferredUIMessage: [ self openOn: anArray ].! !

!GTDebugger classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/12/2011 16:39'!
debugProcess: aProcess

	<primitive: 19> "simulation guard"
	
	WorldState addDeferredUIMessage: [
		self openOn: (GTDebuggerModel process: aProcess) ].! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 10/23/2012 17:30'!
buildBrowser
	browser := GLMTabulator new.
	self installBrowserActions.
	browser title: 'Glamorous Debugger'.
	browser
		row: #stack;
		row: #code;
		row: [:r| r column: #selfInspector;  column: #selfInspectorEvaluator; column: #contextInspector; column: #contextInspectorEvaluator].

	browser transmit to: #stack; andShow: [ :composite |
		composite list 
			title: 'Stack';
			showOnly: 10;
			display: #stack;
			format: [ :each | each methodClass name , '>>' , each methodSelector ] ].
	
	browser transmit fromOutsidePort: #entity; to: #stack port: #selection; transformed: #context.
	browser transmit from: #stack port: #selection; to: #stack port: #pc; transformed: #pc.
	
	browser transmit from: #stack; fromOutsidePort: #entity; to: #code; andShow: [ :composite |
		composite text 
			selectionAct: [:text :context :model | model evaluate: text selectedText in: context ] on: $; entitled: 'Do (;)';
			selectionAct: [:text :context :model |
				(model evaluate: text selectedText in: context) printString. ] on: $/ entitled: 'Print (/)';
			selectionAct: [:text :context :model | (model evaluate: text selectedText in: context) inspect ] on: $' entitled: 'Inspect ('')';
			title: 'Source';
			display: [ :context :model | model methodModel: context ];
			format: #sourceText;
			forSmalltalk: [ :context :model | model receiverClass: context ]].
		
	browser transmit from: #stack; fromOutsidePort: #entity; from: #stack port: #pc; to: #code port: #selectionInterval;
		transformed: [ :context :model :pc | model selectedCodeRange: context ].
		
		
	"Inspect the state of the current object"
	browser transmit from: #stack; fromOutsidePort: #entity; to: #selfInspector; andShow: [ :composite |
		composite list
			showOnly: 50;
			display: [ :context :model | model receiverVariableValuePairList: context];
			format: [:assoc | self keyAsFormatedString: assoc key ] ].
	
	"Select the first entity. Not the best solution or ideea "
	browser transmit from: #stack; fromOutsidePort: #entity; to: #selfInspector port: #selection;
		transformed: [ :context :model | ('self' -> context receiver) ].
	
	browser transmit from: #selfInspector; from: #stack; fromOutsidePort: #entity; to: #selfInspectorEvaluator; 
		andShow: [ :composite |
			composite text
				selectionAct: [ :text :assoc :context :model | model evaluate: text selectedText in: context] on: $; entitled: 'Do (;)';
				display: [ :assoc :context :model | self valueAsFormatedString: assoc value ] ].
			
				"selectionPopulate: #newAttrValue
					on: $o
					entitled: 'Haba (o)'
					with: [:text :assoc :context :model | Compiler evaluate: text selectedText for: context logged: false ] ]."
	"browser transmit from: #selfInspectorEvaluator port: #newAttrValue; to: #selfInspector; ."
			
	"Inspect the context of the current method"
	browser transmit from: #stack;  fromOutsidePort: #entity; to: #contextInspector; andShow: [ :composite |
		composite list
			showOnly: 50;
			display: [ :context :model | model contextVariableValuePairList: context ];
			format: [ :assoc | self keyAsFormatedString: assoc key ] ].
	
	"Select the first entity"
	browser transmit from: #stack; fromOutsidePort: #entity; to: #contextInspector port: #selection;
		transformed: [ :context :model | ('thisContext' -> context) ].
			
	browser transmit from:#contextInspector; from: #stack; fromOutsidePort: #entity; to: #contextInspectorEvaluator; 
		andShow: [ :composite | 
			composite text
				selectionAct: [:text :assoc :context :model | model evaluate: text selectedText in: context] on: $; entitled: 'Do (;)';
				display: [ :assoc :context :model | self valueAsFormatedString: assoc value ] ].
			
	
! !

!GTDebugger methodsFor: 'private building' stamp: 'ToonVerwaest 3/16/2011 11:20'!
installBrowserActions
	self installRestartAction.
	self installStepIntoAction.
	self installStepOverAction.
	self installStepThroughAction.
	self installResumeAction! !

!GTDebugger methodsFor: 'private building' stamp: 'ToonVerwaest 3/12/2011 14:31'!
installRestartAction
	browser 
		act: [ :b :model |
			model restart: self selectedContext.
			self selectTopOfStack: model context  ]
		icon: GLMUIThemeExtraIcons glamorousRestart
		entitled: 'Restart'! !

!GTDebugger methodsFor: 'private building' stamp: 'ToonVerwaest 3/12/2011 11:18'!
installResumeAction
	browser 
		act: [ :b :model |
			"b close."
			model resume ]
		icon: GLMUIThemeExtraIcons glamorousPlay
		entitled: 'Resume' ! !

!GTDebugger methodsFor: 'private building' stamp: 'ToonVerwaest 3/12/2011 15:47'!
installStepIntoAction
	browser 
		act: [ :b :model |
			model stepInto: self selectedContext.
			self selectTopOfStack: model context ]
		icon: GLMUIThemeExtraIcons glamorousInto
		entitled: 'Step into' ! !

!GTDebugger methodsFor: 'private building' stamp: 'ToonVerwaest 3/12/2011 14:31'!
installStepOverAction
	browser 
		act: [ :b :model |
			model stepOver: self selectedContext.
			self selectTopOfStack: model context ]
		icon: GLMUIThemeExtraIcons glamorousOver
		entitled: 'Step over' ! !

!GTDebugger methodsFor: 'private building' stamp: 'ToonVerwaest 3/16/2011 11:19'!
installStepThroughAction
	browser 
		act: [ :b :model |
			model stepThrough: self selectedContext.
			self selectTopOfStack: model context ]
		icon: GLMUIThemeExtraIcons glamorousOver
		entitled: 'Step through' ! !

!GTDebugger methodsFor: 'private' stamp: 'AndreiChis 10/23/2012 15:56'!
keyAsFormatedString: key

	^ [ Text fromString: (key asString contractTo: 50) ]
			on: Error
			do: [ Text string: 'error printing' attribute: TextColor red ] ! !

!GTDebugger methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 16:00'!
model
	^ (browser pane port: #entity) value! !

!GTDebugger methodsFor: 'private' stamp: 'ToonVerwaest 3/13/2011 23:15'!
selectTopOfStack: aContext
	| stackPane |
	stackPane := browser paneNamed: #stack.
	(stackPane port: #selection) value: aContext.
	(stackPane port: #pc) value: aContext pc.
	stackPane update! !

!GTDebugger methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 18:28'!
selectedContext
	^ ((browser paneNamed: #stack) port: #selection) value! !

!GTDebugger methodsFor: 'private' stamp: 'AndreiChis 10/23/2012 15:58'!
valueAsFormatedString: value

	^ [ Text fromString: value printString]
			on: Error
			do: [ Text string: 'error printing' attribute: TextColor red ] ! !

Object subclass: #GTDebugMethodModel
	instanceVariableNames: 'timestamp method methodNode ranges'
	classVariableNames: 'MapCache MapCacheEntries'
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebugMethodModel commentStamp: 'ToonVerwaest 3/13/2011 01:33' prior: 0!
This class gives a method model for debugging.!

!GTDebugMethodModel classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/12/2011 19:38'!
forMethod: aMethod
	^ self new forMethod: aMethod! !

!GTDebugMethodModel methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/13/2011 01:31'!
forMethod: aMethod
	method := aMethod.
	methodNode := method methodNode.

	ranges := Dictionary new.
	
	" Put all ranges with a possitive Key PC in the ranges dictionary "
	methodNode rawSourceRanges
		keysAndValuesDo: [ :node :range |
			node pc = 0
				ifFalse: [ ranges at: node pc put: range ]].

	" Sort all the Key PCs in the sortedKeyPCs "
	"sortedKeyPCs := SortedCollection new."
	" ranges keysDo: [ :pc | sortedKeyPCs add: pc ]."! !

!GTDebugMethodModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/13/2011 01:32'!
source
	^ method holdsTempNames
		ifTrue: [ method getSource ]
		ifFalse: [ methodNode sourceText ]! !

!GTDebugMethodModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 20:15'!
sourceRangeForPC: pc
	^ ranges at: pc ifAbsent: [ ^ 1 to: 0 ].! !

!GTDebugMethodModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 20:21'!
sourceText
	^ self source asText! !

Object subclass: #GTDebuggerModel
	instanceVariableNames: 'context process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebuggerModel classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/12/2011 16:39'!
process: aProcess
	^ self new
		process: aProcess! !

!GTDebuggerModel methodsFor: 'private process' stamp: 'ToonVerwaest 3/12/2011 16:54'!
activePC: aContext
	^ (self isLatestContext: aContext)
		ifTrue: [ context pc ]
		ifFalse: [ self previousPC: aContext ].! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 10:13'!
context
	^ context! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'TudorGirba 10/23/2012 21:19'!
contextVariableValuePairList: aContext
	"Return a collection of 'temporary variables name -> value' for the received context"
	|fieldList|
	self halt.
	fieldList := OrderedCollection new.
	fieldList add: ('thisContext' -> aContext ).
	
	aContext == nil ifTrue: [^fieldList].
	
	fieldList 
		add: ('stack top' -> (aContext stackPtr > 0 ifTrue: [aContext top]));
		add: ('all temp vars' -> aContext tempsAndValues).
	(aContext tempNames size > 0) ifTrue: [
		fieldList addAll: ((1 to: aContext tempNames size) collect: [ :index | 
			(aContext tempNames at: index ) -> (aContext debuggerMap namedTempAt: index in: aContext ) ] ) ].
		
	^ fieldList
					! !

!GTDebuggerModel methodsFor: 'private context' stamp: 'ToonVerwaest 3/12/2011 20:15'!
currentCodeRange: aContext
	^(self methodModel: aContext) sourceRangeForPC: (self activePC: aContext)! !

!GTDebuggerModel methodsFor: 'evaluating actions' stamp: 'ToonVerwaest 3/12/2011 13:13'!
evaluate: expression in: aContext
	^ Compiler new
		evaluate: expression
		in: aContext
		to: aContext receiver! !

!GTDebuggerModel methodsFor: 'private' stamp: 'TudorGirba 10/23/2012 21:26'!
gtInspectorRetrieveVariableValuePairs
	"Return a collection of 'temporary variables name -> value' for the received context"
	|fieldList|
	fieldList := OrderedCollection new.
	fieldList add: ('thisContext' -> context ).
	
	context == nil ifTrue: [^fieldList].
	
	fieldList 
		add: ('stack top' -> (context stackPtr > 0 ifTrue: [context top]));
		add: ('all temp vars' -> context tempsAndValues).
	(context tempNames size > 0) ifTrue: [
		fieldList addAll: ((1 to: context tempNames size) collect: [ :index | 
			(context tempNames at: index ) -> (context debuggerMap namedTempAt: index in: context ) ] ) ].
		
	^ fieldList! !

!GTDebuggerModel methodsFor: 'private process' stamp: 'ToonVerwaest 3/12/2011 16:52'!
isLatestContext: aContext
	^ process suspendedContext == aContext! !

!GTDebuggerModel methodsFor: 'private context' stamp: 'ToonVerwaest 3/12/2011 20:14'!
methodModel: aContext
	^ GTDebugMethodModel forMethod: aContext method! !

!GTDebuggerModel methodsFor: 'private context' stamp: 'ToonVerwaest 3/12/2011 16:50'!
previousPC: aContext
	^ (aContext method pcPreviousTo: aContext pc)
		ifNil: [ aContext pc ]! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 10:13'!
process
	^ process! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'AndreiChis 10/22/2012 10:13'!
process: aProcess
	aProcess stepToSendOrReturn.
	context := aProcess suspendedContext.
	process := aProcess! !

!GTDebuggerModel methodsFor: 'private context' stamp: 'ToonVerwaest 3/12/2011 18:31'!
receiverClass: aContext
	^ aContext receiver class! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'AndreiChis 10/23/2012 16:05'!
receiverVariableValuePairList: aContext
	"Return a collection of 'variable name -> value' for the receiver of the given context"
	|receiver fieldList|
	
	receiver := aContext receiver.
	
	fieldList := OrderedCollection new.
	fieldList 
		add: ('self' -> receiver);
		add: ('all inst vars' -> (receiver longPrintStringLimitedTo: 20000)).	
	fieldList addAll: (receiver class allInstVarNames collect: [:each | each -> (receiver instVarNamed: each) ]).

	receiver class isVariable ifTrue: [
		(1 to: receiver basicSize) collect: [:index | index -> (receiver instVarAt: index)  ]].
	
	^ fieldList
					! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 12:45'!
restart: selectedContext
	self unwindTo: selectedContext.
	process
		restartTop;
		stepToSendOrReturn! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 11:27'!
resume
	process resume! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 18:40'!
selectedCodeRange: selectedContext
	^ self currentCodeRange: selectedContext! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 14:49'!
stack
	^ context stack! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 11:45'!
stackOfSize: size
	^ context stackOfSize: size! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 13:28'!
stepInto
	self stepInto: context! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 13:33'!
stepInto: selectedContext
	context := process step: selectedContext.
	process stepToSendOrReturn.! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 13:29'!
stepOver
	self stepOver: context! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 13:32'!
stepOver: selectedContext
	| newContext |
	newContext := process completeStep: selectedContext.
	context := 
		newContext == selectedContext
			ifTrue: [ process stepToSendOrReturn ]
			ifFalse: [ selectedContext ]! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/16/2011 11:19'!
stepThrough
	self stepThrough: context! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/16/2011 11:24'!
stepThrough: selectedContext
	"Send messages until you return to the present method context.
	 Used to step into a block in the method."
	self halt.
	context := process stepToHome: selectedContext.
	process stepToSendOrReturn.! !

!GTDebuggerModel methodsFor: 'private' stamp: 'ToonVerwaest 3/12/2011 12:45'!
unwindTo: aContext
	|ctx|
	ctx := process popTo: aContext.
	ctx == aContext ifFalse: [ self error: 'Could not unwind stack' ].
	context := aContext! !
